#ifndef CLS_HPP_
#define CLS_HPP_
#define cls_hpp_version "$Revision: 1.7 $"
#include "Types.hpp"


typedef Ptr32 ClsP;

struct ClsLit{
	static const uint32_t  MAX_LIT = max32>>2;
	uint32_t has_next 	: 1;
	uint32_t lbd		: 1;
	uint32_t lit 		: 30;
	explicit ClsLit(const Literal& l, const bool not_last, const bool LBD):has_next(not_last),lbd(LBD),lit(l.idx()){asrt(l.idx()<=MAX_LIT);}
	ClsLit(){}
	Literal getLit()const {return Literal(lit);}
};

class Cls{

	uint32_t lrnt	: 1;
	uint32_t lbd 	: 1;
	uint32_t wtches	: 30;

	ClsLit	 lits[0];

public:
	static inline uint32_t allocSizeFor(const uint32_t lits){return lits-1;}
	bool isLrnt() const {return lrnt;}
	void setLrnt(const bool b){lrnt=b;}
	uint32_t computeMem(){
		uint32_t idx = 0;
		while(lits[idx++].has_next);{}
		return idx +1;
	}

	void setLBD(uint32_t LBD){ asrt(LBD>0); asrt(LBD<=16);
		--LBD; lbd=LBD&1;
		for(uint32_t idx=0; LBD; ++idx){LBD>>=1; asrt(idx<3); lits[idx].lbd = LBD&1;}
	}

	uint32_t compLBD() const{ asrt(isLrnt());
		uint32_t ret = lbd; uint32_t idx=0;
		do{ret += (((uint32_t)lits[idx].lbd)<<(idx+1));	}while(lits[idx].has_next && ++idx<3);
		return ret + 1;
	}

	Cls(const Literal& a, const Literal& b, const bool learnt, const bool LBD):lrnt(learnt),lbd(LBD),wtches(a.idx() ^ b.idx()){
		asrt(a.idx() <= ClsLit::MAX_LIT); asrt(b.idx() <= ClsLit::MAX_LIT);}

	Literal	otherWatcher(const Literal& l)const	{asrt(l.idx() <= ClsLit::MAX_LIT); return Literal(wtches ^ l.idx());}
	void	changeWatchers(const Literal& a, ClsLit* neww, const Literal& oldw){
			asrt(a.idx() <= ClsLit::MAX_LIT); asrt(oldw.idx() <= ClsLit::MAX_LIT); asrt(wtches==(a.idx()^oldw.idx()));
			wtches = a.idx() ^ neww->lit; neww->lit = oldw.idx(); }
	void	unsetWatchers(){wtches =0;}
	void	setWatchers(const Literal& a, const Literal& b){
				asrt(a.idx() <= ClsLit::MAX_LIT); asrt(b.idx() <= ClsLit::MAX_LIT);
				wtches = a.idx() ^ b.idx(); }
	ClsLit*	uwBeg(){return lits;}


};

/*
struct ClsHead{
	uint32_t innr		: 25;
	//uint32_t last		: 10;
	uint32_t del		: 1;
	uint32_t flg		: 1;
	uint32_t lrnt		: 1;
	uint32_t lbd		: 4;

	static const uint32_t LBD_MAX = 16;
    //ClsHead(uint32_t sz,bool lr,const uint32_t& bd):innr(sz-2),last(0),flg(0),lrnt(lr),lbd(bd-1){
    //	asrt(sz>2);asrt(bd>1);asrt(bd<=LBD_MAX);asrt((uint32_t)innr+2==sz);}

	ClsHead(uint32_t sz):innr(sz-2),del(1),flg(0),lrnt(0),lbd(0){asrt(sz>2);}
	ClsHead(uint32_t sz,bool lr,const uint32_t& bd):innr(sz-2),del(0),flg(0),lrnt(lr),lbd(bd-1){
		asrt(sz>2);asrt(bd>1);asrt(bd<=LBD_MAX);}



    const uint32_t  litsCnt() const  					{return innr + 2;}
    const uint32_t  unWatchdCnt() const					{return innr;}
    //void			reduceUnWatchdCount(uint32_t i)		{asrt(i<innr);innr-=i;last=0;}
    void			reduceUnWatchdCount(uint32_t i)		{asrt(i<innr);innr-=i;}
    //void			setSize(uint32_t s)					{asrt(s<=size());asrt(s>2);cnt=s;}
    const bool      isLearnt()                  const  	{return lrnt;}
    void			setLearnt(bool b)					{lrnt = b;}
    const bool		flagged()const						{return flg;}
    void 			setFlg()							{flg=1;}
    void 			clearFlg()							{asrt(flg==1);flg=0;}

    uint32_t		getLBD()const						{return lbd+1;}
    void			setLBD(const uint32_t&  v)			{asrt(v>0);asrt(v<=LBD_MAX); lbd=v-1;}
    bool			isDel() const						{return del;}

    //uint32_t		toInt() const						{return *((uint32_t*)this);} //more control than using operator
    //explicit ClsHead(const uint32_t& ch)				{*((uint32_t*)this)=ch;}
};

class Cls: public ClsHead{
public:
    uint32_t 	watches;

    //All non watching literals start here.
    Literal 	literals[0];

    const uint32_t memSize() const						{return (sizeof(Cls)/4) + unWatchdCnt();}

//private members
private:
    //Construct a part of the clause
    //Cls(const uint32_t& sz, bool learnt):ClsHead(sz,learnt){}
    Cls(const uint32_t& sz, bool learnt, const uint32_t& lbd, const Literal& w0, const Literal& w1)
		:ClsHead(sz,learnt,lbd),watches(w0.idx() ^ w1.idx()){}

    Cls(const Cls& cl);// no copying
    Cls& operator=(const Cls& c){asrt(false);return (Cls&)c;} // no assignment

public:

    Literal			otherWatcher(const Literal& l)const	{return Literal(watches ^ l.idx());}
    //void			setWatchers(const Literal& a, const Literal& b, uint32_t k){watches = a.idx() ^ b.idx(); last = k;}
    void			setWatchers(const Literal& a, const Literal& b){watches = a.idx() ^ b.idx(); }
    void			unsetWatchers(){watches=0;}
    void			setHeader(const ClsHead& h, Literal a, Literal b){
					watches = a.idx() ^ b.idx(); ClsHead::operator=(h); asrt(h.litsCnt()==this->litsCnt());}
    Literal*		uwBeg(){		return literals;}
    const Literal* 	uwEnd()const{	return literals + unWatchdCnt();}
    //Literal&        operator [] (uint32_t i)           	{asrt(i<unWatchdCnt());return literals[i];}
    //const Literal&  operator [] (uint32_t i)	const  	{asrt(i<unWatchdCnt());return literals[i];}

    //inline void             	print(OFStream& out);
    //inline void				removeAt(uint32_t idx);
    //inline void				shrinkToSize(uint32_t new_sz);


    friend class SimplyFire;
    friend class Assym;
    friend class BasicSolver;

protected:
    inline bool asrtSorted() const;

};
*/




#endif /* CLS_HPP_ */
