/*
 * ElimProduct.hpp
 *
 *  Created on: 19.02.2011
 *      Author: stephan
 */

#ifndef ELIMPRODUCT_HPP_
#define ELIMPRODUCT_HPP_
#define elimprod_hpp_version "$Revision: 1.2 $"

#include "ThreadGlobals.hpp"

struct ElimProcut{
	TwoBitsVec<uint32_t>  		blkd_cls_prod;
	vector<vector<Literal> >	elim_cls_prod;

	inline bool asrtAllEmpty();

	void ensureBlkdClsProd(const uint32_t& sz){
		if(sz > blkd_cls_prod.getSize()){blkd_cls_prod.ensureSize(sz,false);}
		LOG2("blkd_cls_prod has size " << blkd_cls_prod.getSize() << " requested was " << sz);
		asrt(asrtAllEmpty());
	}

	void ensureElimClsProd(const uint32_t& sz){
		if(sz > elim_cls_prod.size()){elim_cls_prod.resize(sz);}
		asrt(asrtAllEmpty());
	}


};

class FaktCls{
	uint32_t usd	: 1;
	uint32_t sz 	: 31;
	uint32_t lit_ecp;

public:
	FaktCls(const Literal& a):usd(0),sz(1),lit_ecp(a.idx()){}
	FaktCls(const ECP& e, const uint32_t clssz):usd(0),sz(clssz-1),lit_ecp(e.idx){
			asrt(e.idx==lit_ecp);asrt(sz>1);}
	bool 	isBin()const{return sz==1;}
	ECP 	getECP()const{asrt(!isBin()); return ECP(lit_ecp);}
	Literal getLit()const{asrt(isBin()); return Literal(lit_ecp);}
	uint32_t getSz() const{return sz;}
	void	setECP(const ECP& e,const uint32_t siz){sz=siz-1; lit_ecp = e.idx; asrt(sz>1);}
	bool	isUsed() const{return usd;}
	bool	setUsdNew(){bool prev=usd; usd=1;return !prev;}
};


struct FiniProd{
	//uint32_t 				sz;
	FaktCls  			fctcls;
	vector<Literal>* 	sec_part;
	FiniProd(const FaktCls& fcls, vector<Literal>* sec)
	:fctcls(fcls),sec_part(sec){}
	void setProd(const ECP& e,uint32_t sz){sec_part=NULL; fctcls.setECP(e,sz);}
};



bool ElimProcut::asrtAllEmpty(){
	if(!blkd_cls_prod.allCleared()){
		LOG0("Not all blkd cls prod empty");return false;}
	for(uint32_t i=elim_cls_prod.size();i--;){
		if(!elim_cls_prod[i].empty()){
			LOG0("Not all elim cls prod empty");return false;}
	}
	return true;
}

#endif /* ELIMPRODUCT_HPP_ */
